 /*
 * MAIN Generated Driver File
 * 
 * @file main.c
 * 
 * @defgroup main MAIN
 * 
 * @brief This is the generated driver implementation file for the MAIN driver.
 *
 * @version MAIN Driver Version 1.0.0
*/

/*
? [2024] Microchip Technology Inc. and its subsidiaries.

    Subject to your compliance with these terms, you may use Microchip 
    software and any derivatives exclusively with Microchip products. 
    You are responsible for complying with 3rd party license terms  
    applicable to your use of 3rd party software (including open source  
    software) that may accompany Microchip software. SOFTWARE IS ?AS IS.? 
    NO WARRANTIES, WHETHER EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS 
    SOFTWARE, INCLUDING ANY IMPLIED WARRANTIES OF NON-INFRINGEMENT,  
    MERCHANTABILITY, OR FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT 
    WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY 
    KIND WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF 
    MICROCHIP HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE 
    FORESEEABLE. TO THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP?S 
    TOTAL LIABILITY ON ALL CLAIMS RELATED TO THE SOFTWARE WILL NOT 
    EXCEED AMOUNT OF FEES, IF ANY, YOU PAID DIRECTLY TO MICROCHIP FOR 
    THIS SOFTWARE.
*/
#include "mcc_generated_files/system/system.h"
#include "OLED128x64.h"

volatile unsigned char  I2C_Wbuffer[16];   
volatile unsigned char  I2C_Rbuffer[16] ;
unsigned char           ASCII_Buffer[20];

volatile bool bRTCOverflow = 0 ;
uint8_t     StateMachine = 0 ;
uint16_t    Counter = 0 ;
uint16_t    adcResult ;


void    LED_Shift(void) ;

void    RTC_OVF_Callback(void)
{
    bRTCOverflow = 1 ;
}

void    ADC0_ISR(void)
{
        adcResult = ADC0_GetConversionResult();
}
/*
    Main application
*/

int main(void)
{
    SYSTEM_Initialize();
    // Important workaround for I2C Pin MAX setting
    // Set  PC2/PC3 as Host/Client pin of TWI0 
    PORTMUX.TWIROUTEA = 0b00000010;             
    // Important workaround for I2C Pin MAX setting 
    RTC_SetOVFIsrCallback(RTC_OVF_Callback);
    ADC0_RegisterResrdyCallback(ADC0_ISR);
    ADC0_SetWindowChannel(ADC_MUXPOS_AIN0_gc);

        OLED_Init();                                                    
        OLED_CLS();
        OLED_Put8x16Str(0,0,"APP-All MCU 2023");
        
    while(1)
    {
        if (bRTCOverflow ==1)
        {
            LED_Shift();
            bRTCOverflow = 0;
            printf("ADC Result :  %d \n\r", adcResult);
            sprintf (ASCII_Buffer,"ADC = %4d",adcResult) ;
                OLED_Put8x16Str(0,2,(uint8_t*)ASCII_Buffer) ;      
        }
    }    
}

void    LED_Shift(void)
{
 switch(StateMachine)
        {
            case 0:
                LED1_SetHigh();
                LED2_SetLow();
                LED3_SetLow();
                LED4_SetLow();
                StateMachine ++ ;
                break ;
            case 1:
                LED1_SetLow();
                LED2_SetHigh();
                LED3_SetLow();
                LED4_SetLow();    
                StateMachine ++ ;
                break ;
            case 2 :
                LED1_SetLow();
                LED2_SetLow();
                LED3_SetHigh();
                LED4_SetLow();      
                StateMachine ++ ;
                break ;
            case 3:
                LED1_SetLow();
                LED2_SetLow();
                LED3_SetLow();
                LED4_SetHigh();    
                StateMachine ++ ;
                break ;
            case 4:
                LED1_SetLow();
                LED2_SetLow();
                LED3_SetHigh();
                LED4_SetLow();       
                StateMachine ++ ;
                break ;                
            case 5:
                LED1_SetLow();
                LED2_SetHigh();
                LED3_SetLow();
                LED4_SetLow();      
                StateMachine = 0 ;
                break ;                                               
            default :
                break ;
                                           
        }    
}